function [ fhat, norm_fct_square ] = bspline_mixed_10d_hat( freq_out )
%BSPLINE_MIXED_10D_HAT Summary of this function goes here
%   Detailed explanation goes here

% valout = bspline2t_nd(x(:,[1 3])) .* bspline_o4(x(:,9)) ...
%        + bspline4t_nd(x(:,[4 5])) .* bspline_o2(x(:,[2 7])) ...
%        + bspline2t_nd(x(:,[8])) .* bspline_o2(x(:,[6 10]));

fhat = zeros(size(freq_out,1),1);

ind=find(sum(abs(freq_out(:,[2 4 5 6 7 8 10])),2)==0);
fhat(ind) = fhat(ind) + bspline2t_chat_nd(freq_out(ind,[1 3])) .* bspline_o4_hat(freq_out(ind,9));

ind=find(sum(abs(freq_out(:,[1 3 6 8 9 10])),2)==0);
fhat(ind) = fhat(ind) + bspline4t_chat_nd(freq_out(ind,[4 5])) .* bspline_o2_hat(freq_out(ind,[2 7]));

ind=find(sum(abs(freq_out(:,[1 2 3 4 5 7 9])),2)==0);
fhat(ind) = fhat(ind) + bspline2t_chat_nd(freq_out(ind,8)) .* bspline_o2_hat(freq_out(ind,[6 10]));

fhat = fhat./2.^(0.5*sum(freq_out(:,[1 3 4 5 8])~=0,2));

[~, bspline2t_normcheb_d1_sq] = bspline2t_normcheb(1);
[~, bspline2t_normcheb_d2_sq] = bspline2t_normcheb(2);
[~, bspline4t_normcheb_d2_sq] = bspline4t_normcheb(2);

% norm_fct_square = pi^4 * bspline2t_normcheb_d1_sq ...
%   + pi^3 * bspline2t_normcheb_d2_sq ...
%   + pi^3 * bspline4t_normcheb_d2_sq ...
%   + pi^5 * 2 * bspline4t_chat_nd(zeros(1,2)) * bspline_o2_hat(zeros(1,4)) .* bspline2t_chat_nd(0) ...
%   + pi^5 * 2 * bspline2t_chat_nd(zeros(1,3)) * bspline_o2_hat(zeros(1,2)) * bspline_o4_hat(0) ...
%   + pi^5 * 2 * bspline2t_chat_nd(zeros(1,2)) * bspline4t_chat_nd(zeros(1,2)) * bspline_o2_hat(zeros(1,2)) * bspline_o4_hat(0);

norm_fct_square = bspline2t_normcheb_d1_sq/pi ...
  + bspline2t_normcheb_d2_sq/pi^2 ...
  + bspline4t_normcheb_d2_sq/pi^2 ...
  + 2 * bspline4t_chat_nd(zeros(1,2)) * bspline_o2_hat(zeros(1,4)) .* bspline2t_chat_nd(0) ...
  + 2 * bspline2t_chat_nd(zeros(1,3)) * bspline_o2_hat(zeros(1,2)) * bspline_o4_hat(0) ...
  + 2 * bspline2t_chat_nd(zeros(1,2)) * bspline4t_chat_nd(zeros(1,2)) * bspline_o2_hat(zeros(1,2)) * bspline_o4_hat(0);

end

