function out = sublin_cosamp_v2_mixed_chebyshev_bspline_mixed10_run(trial_n, N_array, s_array, psf_array, cosamp_max_iter, tau)
%demo file to run the sublinearized CoSaMP ( Chebyshev basis/ Noisy samples)
out = 0;

% tau = 1e-12;
%cosamp_max_iter = 10;
basis_type = 'mixed';
pairing_type = 'pairing_large';
L = 0;

test_fct = @bspline_mixed_10d;
test_fhat = @bspline_mixed_10d_hat;

for N=N_array% the number of possible entries in each dimension
  M=N;
    d = 10;
basis_types = cell(d,1);
for jj=1:d
  switch jj
    case {1,3,4,5,8}
      basis_types{jj} = 'chebyshev';
    otherwise
      basis_types{jj} = 'fourier';
  end
end

        for s=s_array%sparsity
          for pairing_sampl_factor = psf_array
rng('default');
                fname = ['Bspline_mixed10_v2_N', int2str(N),'_d',int2str(d),'_s',int2str(s),'_psf',mat2str(pairing_sampl_factor),'_',basis_type,'_t',mat2str(trial_n),'_it',mat2str(cosamp_max_iter),'_sub_v2_m24s_',pairing_type,'.mat'];%file name for statistics
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                m_ls=50*s;% sample number for the least square problem
                m_1=round(pairing_sampl_factor*s);%sample number m_1 for pairing
                m_2=4*s; %round(2^(d/2)*s);%sample number m_2 for pairing
                m_entryid = [m_1,m_2];
%                 m_entryid = [];
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                iter_array = nan(trial_n,1);
                tElapsed_sam_array = nan(trial_n,1);
                tElapsed_tot_array = nan(trial_n,1);
                sam_num_array = nan(trial_n,1);
                error2_array = nan(trial_n,1);
                error_trunc2_array = nan(trial_n,1);
                error_alias2_array = nan(trial_n,1);

                for trial=1:trial_n
                  fprintf('d=%d N=%d s=%d psf=%.1f trial %d/%d start\n', d, N, s, pairing_sampl_factor, trial, trial_n);

                  [iter,~,~,aa,cc,tElapsed_sam,tElapsed_tot,~,sam_num]=sublin_cosamp_v2_func_fct(test_fct,M,d,basis_types,s,m_entryid,L,tau,m_ls,m_1,m_2,cosamp_max_iter,pairing_type);

                  basis_indices_detected = aa;
                  fhat_tilde = cc;

                  freq_fft_1d=(floor(-M/2):floor(M/2))';
                  freq_fourier_detected = nan(size(basis_indices_detected,1),d);
                  for jj=1:d
                    switch basis_types{jj}
                      case 'fourier'
                        k = basis_indices_detected(:,jj);
                        freq_fourier_detected(:,jj) = freq_fft_1d((-1).^k.*ceil(k/2) + ceil(M/2) + 1);
                      otherwise
                        freq_fourier_detected(:,jj) = basis_indices_detected(:,jj);
                    end
                  end
                  [fhat, norm_fct_square] = test_fhat(freq_fourier_detected);

                  error_trunc2 = sqrt(norm_fct_square - pi^0 * sum(abs(fhat).^2)) / sqrt(norm_fct_square);
                  error_alias2 = pi^(0/2) *  norm(fhat-fhat_tilde) / sqrt(norm_fct_square);
                  error2 = sqrt(norm_fct_square - sum(pi^0 * abs(fhat).^2 ) + sum(pi^0 * abs(fhat_tilde-fhat).^2)) / sqrt(norm_fct_square);

                  fprintf('d=%d N=%d s=%d psf=%.1f tr %d/%d: t=%.3es, err2=%.3e (%.1e|%.1e)\n\n', d, N, s, pairing_sampl_factor, trial, trial_n, tElapsed_tot, error2, error_trunc2, error_alias2);

                  iter_array(trial) = iter;
                  tElapsed_sam_array(trial) = tElapsed_sam;
                  tElapsed_tot_array(trial) = tElapsed_tot;
                  sam_num_array(trial) = sam_num;
                  error2_array(trial) = error2;
                  error_trunc2_array(trial) = error_trunc2;
                  error_alias2_array(trial) = error_alias2;
                  
                  save(fname,'N','d','s','m_ls','m_entryid','m_1','m_2','trial_n','cosamp_max_iter',...
                    'iter_array','tElapsed_sam_array','tElapsed_tot_array','sam_num_array',...
                    'error2_array','error_trunc2_array','error_alias2_array','tau');%saving statistics        
                end
            end
        end
 
end
